#include <GL/gl.h>
#include <GL/glut.h>
#include <math.h>
#include <malloc.h>
#include <memory.h>

#include "debug.h"
#include "ball.h"

void BallDraw(const BALL*b)
{
	const float a=0.1f,d=0.2f;
	int i=b->index;
	glMaterialfv(GL_FRONT, GL_AMBIENT, (float[]){a*(i&1),a*(i&2),a*(i&4), 1.0f});
	glMaterialfv(GL_FRONT, GL_DIFFUSE,  (float[]){d*(i&1),d*(i&2),d*(i&4), 1.0f});
	glMaterialfv(GL_FRONT, GL_SPECULAR, (float[]){1.0f, 1.0f, 1.0f, 1.0f});
	glMaterialfv(GL_FRONT, GL_SHININESS, (float[]){32.0f});
	
	glTranslate(b->pNode->Pos.v[0], b->pNode->Pos.v[1], b->pNode->Pos.v[2]);
	glutSolidSphere(b->pNode->r, 16, 16);
}

BALL* NewBall(VECTOR3*Pos, VECTOR3*Vel, v3unit_t r, v3unit_t w, int index)
{
	BALL*b=(BALL*)malloc(sizeof(BALL));
	b->pNode=NewNode(Pos, r, w, 1);
	b->pNode->apForce[0]=ForceGravity;
	b->pNode->apForceData[0]=NewGravityData(b->pNode);
	
	memcpy(&b->pNode->Vel, Vel, sizeof(VECTOR3));

	b->index=index;
	return b;
}

void DeleteBall(BALL*b)
{
	free(b);
}
