#include <malloc.h>

#include "flag.h"

#include "debug.h"
#include "model.h"
#include "wind.h"

const v3unit_t FlagNode_r=0.04f;
const v3unit_t FlagNode_w=2.0f;

///
MODEL* NewFlag(int Horizontal, int Locked, //@bN
	v3unit_t hard,
	v3unit_t Width, v3unit_t Height,	//傫
	unsigned int SWidth, unsigned int SHeight)	//
{
	MODEL*pNew=(MODEL*)malloc(sizeof(MODEL));
	pNew->NodeCnt=SWidth*SHeight;
	pNew->apNode=(NODE**)malloc(sizeof(NODE*)*pNew->NodeCnt);

	pNew->ForceCnt=2;//d́CCR,
	pNew->apForce=(FORCE**)malloc(sizeof(FORCE*)*pNew->ForceCnt);
	pNew->apForceData=(void**)malloc(sizeof(void*)*pNew->ForceCnt);
	
	int i;
	//m[h̒ǉ
	int Length=pNew->NodeCnt;
	v3unit_t PerWidth=Width/(SWidth-1);
	v3unit_t PerHeight=Height/(SHeight-1);
	for(i=0; i<Length; i++)
	{
		if(Horizontal)
		{
			pNew->apNode[i]=NewNode(
				&(VECTOR3){{PerWidth*(i%SWidth), 0.0f, Height/2-PerHeight*(i/SWidth)}}
				, FlagNode_r, FlagNode_w
				, 1	//d
				);
		}
		else
		{
			pNew->apNode[i]=NewNode(
				&(VECTOR3){{PerWidth*(i%SWidth), Height-PerHeight*(i/SWidth), 0.0f}}
				, FlagNode_r, FlagNode_w
				, 1	//d
				);
		}
		//d
		pNew->apNode[i]->apForce[0]=ForceGravity;
		pNew->apNode[i]->apForceData[0]=NewGravityData(pNew->apNode[i]);
	}		
	//N̒ǉ
	pNew->LinkCnt=(SWidth-1)*SHeight	//
		+(SHeight-1)*SWidth				//c
		+SHeight*(Locked?2:1);			//tbN

	//
	pNew->apLink=(LINK**)malloc(sizeof(LINK*)*pNew->LinkCnt);
	Length=(SWidth-1)*SHeight;
	int Cnt=0;
	for(i=0; i<pNew->NodeCnt; i++)
	{
		if(i%SWidth!=SWidth-1)
		{
			pNew->apLink[Cnt++]=StringNew(
				pNew->apNode[i],
				pNew->apNode[i+1],
				hard);
		}
	}
	int Tate=Cnt;
	
	Length=(SHeight-1)*SWidth;
	//ĉȂ
	for(i=0; i<Length; i++)
	{
		pNew->apLink[Cnt++]=StringNew(
			pNew->apNode[i],
			pNew->apNode[i+SWidth],
			hard);
	}
	
	//tbN
	
	for(i=0; i<SHeight; i++)
	{
		int NodeIndex=(SHeight-i-1)*SWidth;
		pNew->apLink[Cnt]=HookNew(
			pNew->apNode[NodeIndex],
			&pNew->apNode[NodeIndex]->Pos);
		Cnt++;
		
		if(Locked)
		{
			NodeIndex=(SHeight-i-1)*SWidth+SWidth-1;
			pNew->apLink[Cnt]=HookNew(
				pNew->apNode[NodeIndex],
				&pNew->apNode[NodeIndex]->Pos);	
			Cnt++;
		}
	}
	
	//|S
	pNew->SurfaceCnt=(SWidth-1)*(SHeight-1);
	pNew->apSurface=(SURFACE**)malloc(sizeof(SURFACE*)*pNew->SurfaceCnt);
	int PolyIndex=0;
	int Num=pNew->NodeCnt;
	for(i=0; i<Num-SWidth; i++)
	{
		if(i%SWidth==SWidth-1)
			continue;
		int x, y;
		x=(i/SWidth)*SWidth+i%SWidth+Tate;
		if(Horizontal)
		{
			pNew->apSurface[PolyIndex]=NewSurface(
				pNew->apLink[PolyIndex],			pNew->apLink[x+1],
				pNew->apLink[PolyIndex+SWidth-1],	pNew->apLink[x]);
		}
		else
		{
			pNew->apSurface[PolyIndex]=NewSurface(
				pNew->apLink[PolyIndex],			pNew->apLink[x],
				pNew->apLink[PolyIndex+SWidth-1],	pNew->apLink[x+1]);
		}		
		PolyIndex++;
	}
	//CR
	pNew->apForce[0]=AirRegDoNext;
	pNew->apForceData[0]=NewAirRegData(pNew->SurfaceCnt, pNew->apSurface);
	//
	pNew->apForce[1]=WindDoNext;
	pNew->apForceData[1]=NewWindData(pNew->SurfaceCnt, pNew->apSurface);
	return pNew;
}
