#include <malloc.h>
#include <memory.h>

#include "debug.h"
#include "link.h"

int g_Breakable=0;

void SetBreakable(int Stat){g_Breakable=Stat;}

int ReturnTrue(void*p){return 1;}

void DoNothing(void*p){}

void StringDo(void*pData)
{
	STRING*l=(STRING*)pData;
	if(l->Break)
		return;
	v3unit_t Length=v3GetDist(&(l->apNode[0]->LPos), &(l->apNode[1]->LPos));
	v3unit_t Force=((Length-l->NormalLength)/Length)*l->Hard/2;
	
    VECTOR3 Dist;
	v3GetVDist(&Dist, &l->apNode[0]->LPos, &l->apNode[1]->LPos);
    int i;
	for(i=0; i<3; i++)
	{
		Dist.v[i]=Force*Dist.v[i];
	}
	v3MinusEq(&l->apNode[0]->Pos, &Dist);
	v3PlusEq(&l->apNode[1]->Pos, &Dist);
}

void StringDoFinal(void*pData)
{
	if(g_Breakable)
	{
		STRING*s=(STRING*)pData;
		if(v3GetDist(&s->apNode[0]->Pos, &s->apNode[1]->Pos)
			> s->NormalLength*1.2)
		{
			s->Break=1;
		}
	}
}


LINK* StringNew(NODE*n0, NODE*n1, v3unit_t hard)
{
	LINK*l=malloc(sizeof(LINK));
	STRING*s=malloc(sizeof(STRING));
	s->apNode[0]=n0;
	s->apNode[1]=n1;
	s->Hard=hard;
	s->NormalLength=v3GetDist(&n0->Pos, &n1->Pos);	
	s->Break=0;
	
	l->pDoFunc=StringDo;
	l->pDoFinalFunc=StringDoFinal;
	l->pGetNode=StringGetNode;
	l->pEnableFunc=StringEnable;
	l->pData=s;
	return l;
}

NODE* StringGetNode(void*pData, int i)
{
	return ((STRING*)pData)->apNode[i];
}

int StringEnable(void*pData)
{
	return !((STRING*)pData)->Break;
}

LINK* HookNew(NODE*n, VECTOR3*v)
{
	Assert(v, "v==NULL");
	LINK*l=malloc(sizeof(LINK));
	HOOK*h=malloc(sizeof(HOOK));
	h->pNode=n;
	memcpy(&h->HookPos, v, sizeof(VECTOR3));
	l->pDoFunc=HookDo;
	l->pDoFinalFunc=DoNothing;
	l->pGetNode=HookGetNode;
	l->pEnableFunc=ReturnTrue;
	l->pData=h;
	return l;
}

void HookDo(void*pData)
{
	Assert(pData, "pData==NULL");
	HOOK*h=(HOOK*)pData;
	memcpy(&h->pNode->Pos, &h->HookPos, sizeof(VECTOR3));
}

NODE* HookGetNode(void*pData,int i)
{
	Assert(pData, "pData==NULL");
	return ((HOOK*)pData)->pNode;
}
