#include <malloc.h>
#include <stdlib.h>

#include "debug.h"
#include "model.h"
#include "wind.h"

void ModelDraw(MODEL*m)
{
	int i;
	for(i=0; i<m->SurfaceCnt; i++)
	{
		SurfaceDraw(m->apSurface[i]);
	}
}

///@vZ
void ModelCalcNV(MODEL*m)
{
	FOR_EACH_SURFACE(m->apSurface, m->SurfaceCnt, CalcNormalVector);
	ClearNormalVector(m->NodeCnt, m->apNode);
	AddNormalVector(m->SurfaceCnt, m->apSurface);
	NormalizeNormalVector(m->NodeCnt, m->apNode);
}

///
void ModelAdjust(MODEL*m)
{
	FOR_EACH_LINK_DO(m->apLink, m->LinkCnt, pDoFunc);
	FOR_EACH_NODE(m->apNode, m->NodeCnt, NodePos2LPos);
}

void ModelFinal(MODEL*m)
{
	FOR_EACH_LINK_DO(m->apLink, m->LinkCnt, pDoFinalFunc);
}

void ModelForce(MODEL*m)
{
	int i, Cnt=m->ForceCnt;
	FORCE**apForce=m->apForce;
	void **apForceData=m->apForceData;
	for(i=0; i<Cnt; i++)
		(*apForce[i])(apForceData[i]);
}
