#include <memory.h>
#include <malloc.h>

#include "node.h"

NODE* NewNode(VECTOR3*Pos, v3unit_t r, v3unit_t w, int ForceCnt)
{
	NODE*n=(NODE*)malloc(sizeof(NODE));
	memcpy(&n->Pos, Pos, sizeof(VECTOR3));
	memcpy(&n->BPos, Pos, sizeof(VECTOR3));
	memcpy(&n->LPos, Pos, sizeof(VECTOR3));
	memcpy(&n->Vel, &(VECTOR3){{0.0,0.0,0.0}}, sizeof(VECTOR3));
	n->r=r;
	n->w=w;
	n->ForceCnt=ForceCnt;
	n->apForce=(FORCE**)malloc(sizeof(FORCE*)*n->ForceCnt);
	n->apForceData=(void**)malloc(sizeof(void*)*n->ForceCnt);
	return n;
}

void NodeCalcVel(NODE*n)
{
	v3Minus(&n->Vel, &n->Pos, &n->BPos);
	memcpy(&n->BPos, &n->Pos, sizeof(VECTOR3));
}


/** w肵ړ
 */
void NodeMove(NODE*n, const VECTOR3*dist)
{
	v3PlusEq(&n->Pos, dist);
}

/** xړ
 */
void NodeAddVel(NODE*n)
{
	NodeMove(n, &n->Vel);
}	
	
void NodePos2LPos(NODE*n)
{
	memcpy(&n->LPos, &n->Pos, sizeof(VECTOR3));
}

/** m[hm̏Փ˔s
	@retval 0.0f	Փ˂ĂȂ
	@retval <0.0f	Xɑ傫Ă
	@return >0.0f	߂荞ł
 */
v3unit_t NodeHitCheck(const NODE*n0, const NODE*n1)
{
	v3unit_t dx=n0->LPos.v[0]-n1->LPos.v[0];
	v3unit_t dy=n0->LPos.v[1]-n1->LPos.v[1];
	v3unit_t dz=n0->LPos.v[2]-n1->LPos.v[2];
	v3unit_t r=n0->r+n1->r;
	
	if(dx < -r)
		return -1.0f;
			
	if(
		//ȏՓ˃`FbN
		(dy < r || dy > -r)&&
		(dz < r || dz > -r)
	)
	{
		//ɏՓ˃`FbN
		v3unit_t Length= sqrt(
			dx*dx+
			dy*dy+
			dz*dz);
		if(Length<r)
			return Length;
	}
	return 0.0f;
}

/** m[hԂ̋̐
 */
int NodesAdjust(NODE**apNode)
{
	int Cnt;
	for(Cnt=0; apNode[Cnt]; Cnt++)
	{
		NodePos2LPos(apNode[Cnt]);
	}
	
	//Debug("%d",Cnt);	
	v3unit_t Length,Force,x;
	VECTOR3 Dist, Move;
	NODE*n0,*n1;
	for(int i=0; i<Cnt; i++)
	{
		n0=apNode[i];
		for(int j=i; j<Cnt; j++)
		{
			n1=apNode[j];
			
			Length=NodeHitCheck(n0,n1);
			if(Length>0.0f)
			{
				Force=((Length - n0->r - n1->r)/Length);
				v3GetVDist(&Dist, &n0->LPos, &n1->LPos);
				x=(n1->w/(n0->w+n1->w));
				v3Mult(&Move, &Dist, x*Force);
				v3MinusEq(&n0->Pos, &Move);
				v3Mult(&Move, &Dist, (1.0f-x)*Force);
				v3PlusEq(&n1->Pos, &Move);
			}
			else if(Length<0.0f)
				break;
		}
		//nʂƂ̏Փ˔
		//if(n0->LPos.v[1]<n0->r-3.0f)
		//	n0->Pos.v[1]+=((n0->r-3.0f)-n0->LPos.v[1]);
	}
}

void NodesMove(NODE**apNode)
{
	int i;
	for(i=0; apNode[i]; i++)
		NodeCalcVel(apNode[i]);
	for(i=0; apNode[i]; i++)
		NodeAddVel(apNode[i]);
}

void NodesForce(NODE**apNode)
{
	int i,j, Cnt;
	NODE*n;
	for(i=0; apNode[i]; i++)
	{	
		n=apNode[i];
		Cnt=n->ForceCnt;
		for(j=0; j<Cnt; j++)
		{
			n->apForce[j](n->apForceData[j]);
		}
	}
}
