#include <math.h>
#include <malloc.h>

#include "skirt.h"

#include "debug.h"
#include "model.h"
#include "wind.h"

const v3unit_t SkirtNode_r=0.01f;
const v3unit_t SkirtNode_w=2.0f;

MODEL* NewSkirt(
	v3unit_t hard,
	v3unit_t Width, v3unit_t Height,	//傫
	unsigned int SWidth, unsigned int SHeight)	//
{
	MODEL*pNew=(MODEL*)malloc(sizeof(MODEL));
	pNew->NodeCnt=SWidth*SHeight;
	pNew->apNode=(NODE**)malloc(sizeof(NODE*)*pNew->NodeCnt);

	pNew->ForceCnt=2;//d́CCR,
	pNew->apForce=(FORCE**)malloc(sizeof(FORCE*)*pNew->ForceCnt);
	pNew->apForceData=(void**)malloc(sizeof(void*)*pNew->ForceCnt);
	
	int i, s;
	//m[h̒ǉ
	v3unit_t pi=asin(1.0)*2.0; 
	v3unit_t per=2.0f*pi/SWidth;
	v3unit_t PerHeight=Height/(SHeight-1);
	v3unit_t PerR=0.7*Width/(SHeight-1);;
	v3unit_t R;
	for(i=0; i<pNew->NodeCnt; i++)
	{
		R=(Width/2+PerR*(int)(i/SWidth));
		//Debug("R:%f", R);
		s=i%SWidth;	
		pNew->apNode[i]=NewNode(
			&(VECTOR3){{
				Width/2+(cos(s*per))*R, 
				Height/2-PerHeight*((int)(i/SWidth)),
				(sin(s*per))*R-Width/2}}
			, SkirtNode_r, SkirtNode_w
			, 1	//d
			);
		//d
		pNew->apNode[i]->apForce[0]=ForceGravity;
		pNew->apNode[i]->apForceData[0]=NewGravityData(pNew->apNode[i]);
	}		
	//N̒ǉ
	pNew->LinkCnt=SWidth*SHeight	//
		+(SHeight-1)*SWidth				//c
		+SWidth;			//tbN

	pNew->apLink=(LINK**)malloc(sizeof(LINK*)*pNew->LinkCnt);
	int Cnt=0;
	for(i=0; i<pNew->NodeCnt; i++)
	{
		//
		if(i%SWidth!=SWidth-1)
		{
			pNew->apLink[Cnt++]=StringNew(
				pNew->apNode[i],
				pNew->apNode[i+1],
				hard);
		}
		else
		{
			pNew->apLink[Cnt++]=StringNew(
				pNew->apNode[i],
				pNew->apNode[i-SWidth+1],
				hard);
		}
	}
	
	for(i=0; i<pNew->NodeCnt; i++)
	{
		//ĉȂ
		if(i<pNew->NodeCnt-SWidth)
		{
			pNew->apLink[Cnt++]=StringNew(
				pNew->apNode[i],
				pNew->apNode[i+SWidth],
				hard);
		}
	}
	
	//tbN
	
	for(i=0; i<SWidth; i++)
	{
		int NodeIndex=i;
		pNew->apLink[Cnt]=HookNew(
			pNew->apNode[NodeIndex],
			&pNew->apNode[NodeIndex]->Pos);
		Cnt++;
	}
	
	//|S
	pNew->SurfaceCnt=(SWidth)*(SHeight-1);
	pNew->apSurface=(SURFACE**)malloc(sizeof(SURFACE*)*pNew->SurfaceCnt);
	int PolyIndex=0;
	for(i=0; i<pNew->NodeCnt-SWidth; i++)
	{
		if(i%SWidth!=SWidth-1)
		{
			pNew->apSurface[PolyIndex++]=NewSurface(
				pNew->apLink[i],		pNew->apLink[i+pNew->NodeCnt+1],
				pNew->apLink[i+SWidth],	pNew->apLink[i+pNew->NodeCnt]);
		}
		else
		{
			pNew->apSurface[PolyIndex++]=NewSurface(
				pNew->apLink[i],		pNew->apLink[i+pNew->NodeCnt-SWidth+1],
				pNew->apLink[i+SWidth],	pNew->apLink[i+pNew->NodeCnt]);
		}
	}
	//CR
	pNew->apForce[0]=AirRegDoNext;
	pNew->apForceData[0]=NewAirRegData(pNew->SurfaceCnt, pNew->apSurface);
	//
	pNew->apForce[1]=WindDoNext;
	pNew->apForceData[1]=NewWindData(pNew->SurfaceCnt, pNew->apSurface);
	return pNew;
}
