#include <GL/gl.h>
#include <GL/glut.h>
#include <malloc.h>
#include <stdlib.h>
#include <memory.h>

#include "debug.h"
#include "surface.h"

const double K=5.0;

//@vZ
void CalcNormalVector(SURFACE*s)
{
	VECTOR3 v1,v2;
	v3Minus(&v1, &s->apNode[0]->Pos, &s->apNode[1]->Pos);
	v3Minus(&v2, &s->apNode[2]->Pos, &s->apNode[1]->Pos);
	
	v3GetVP(&s->NormalVector,&v1,&v2);
	v3unit_t Length=v3GetLength(&s->NormalVector);
	v3DivEq(&s->NormalVector,-Length);
}

void ClearNormalVector(int Cnt, NODE**apNode)
{
	int i;
	for(i=0; i<Cnt; i++)
	{
		apNode[i]->NormalVector.v[0]=0.0f;
		apNode[i]->NormalVector.v[1]=0.0f;
		apNode[i]->NormalVector.v[2]=0.0f;
	}
}

void AddNormalVector(int Cnt, SURFACE**apSurface)
{
	int i,j;
	for(i=0; i<Cnt; i++)
	{
		for(j=0; j<4; j++)
		{
			v3PlusEq(&apSurface[i]->apNode[j]->NormalVector,
				&apSurface[i]->NormalVector);
		}
	}
}

void NormalizeNormalVector(int Cnt, NODE**apNode)
{
	int i;
	v3unit_t Length;
	for(i=0; i<Cnt; i++)
	{
		Length=v3GetLength(&apNode[i]->NormalVector);
		v3DivEq(&apNode[i]->NormalVector, Length);
	}
}

//|S`
void SurfaceDraw(SURFACE*s)
{
	//glNormal3v(s->NormalVector.v);
	int i;
	for(i=0; i<4; i++)
	{
		if(!s->apLink[i]->pEnableFunc(s->apLink[i]->pData))
			return;
	}
	
	
	for(i=0; i<4; i++)
	{
		glNormal3v(s->apNode[i]->NormalVector.v);
		glVertex3v(s->apNode[i]->Pos.v);
	}
}

/** 4̃Nʂ
	
	@note K l0->l1->l2->l3̏łȂĂ鎖
 */
SURFACE* NewSurface(LINK*l0,LINK*l1,LINK*l2,LINK*l3)
{
	SURFACE*pNew=(SURFACE*)malloc(sizeof(SURFACE));
	pNew->apLink[0]=l0;
	pNew->apLink[1]=l1;
	pNew->apLink[2]=l2;
	pNew->apLink[3]=l3;
	
	void*apData[4]={
		pNew->apLink[0]->pData,
		pNew->apLink[1]->pData,
		pNew->apLink[2]->pData,
		pNew->apLink[3]->pData};
	if(	(pNew->apLink[0]->pGetNode(apData[0],0)
			==pNew->apLink[1]->pGetNode(apData[1],0))||
		(pNew->apLink[0]->pGetNode(apData[0],0)
			==pNew->apLink[1]->pGetNode(apData[1],1)))
	{
		pNew->apNode[0]=pNew->apLink[0]->pGetNode(apData[0],1);
		pNew->apNode[1]=pNew->apLink[0]->pGetNode(apData[0],0);
	}
	else
	{
		pNew->apNode[0]=pNew->apLink[0]->pGetNode(apData[0],0);
		pNew->apNode[1]=pNew->apLink[0]->pGetNode(apData[0],1);
	}
	for(int i=1; i<3; i++)
	{
		pNew->apNode[i+1]=
			(pNew->apNode[i]==pNew->apLink[i]->pGetNode(apData[i],0))?
			pNew->apLink[i]->pGetNode(apData[i],1):
			pNew->apLink[i]->pGetNode(apData[i],0);
	}
	return pNew;
}

void AirR(SURFACE*s)
{
	int i;
	for(i=0; i<4; i++)
	{
		if(!s->apLink[i]->pEnableFunc(s->apLink[i]->pData))
			return;
	}
	
	v3unit_t Inner, Speed;
	VECTOR3 temp;
	//CR
	for(i=0; i<4; i++)
	{
		Inner=v3GetIP(&s->apNode[i]->Vel, &s->NormalVector);
		Inner=Inner>0.0f?Inner:-Inner;
		Speed=v3GetLength(&s->apNode[i]->Vel);
		v3Mult(&temp, &s->apNode[i]->Vel, Speed*K*Inner);
		v3MinusEq(&s->apNode[i]->Pos, &temp);
		//ꂼ̃m[h̖@ݒ
		memcpy(&s->apNode[i]->NormalVector, &s->NormalVector, sizeof(VECTOR3));
	}
}

void AirRegDoNext(void*pData)
{
	AIRREG*a=(AIRREG*)pData;
	int i,Cnt=a->SurfaceCnt;
	for(i=0; i<Cnt; i++)
		AirR(a->apSurface[i]);
	
}

void* NewAirRegData(int SurfaceCnt, SURFACE**apSurface)
{
	AIRREG*a=malloc(sizeof(AIRREG));
	a->SurfaceCnt=SurfaceCnt;
	a->apSurface=apSurface;
	return (void*)a;
}

void SurfaceMove(SURFACE*s, const VECTOR3*d)
{
	for(int i=0; i<4; i++)
	{
		NodeMove(s->apNode[i], d);
	}
}
