#include "vector3.h"

void v3Set(VECTOR3*v, v3unit_t x, v3unit_t y, v3unit_t z)
{
	v->v[0]=x;
	v->v[1]=y;
	v->v[2]=z;
}

/** ς߂
 */
double v3GetIP(const VECTOR3*restrict v1, const VECTOR3*restrict v2)
{
	return v1->v[0]*v2->v[0] + v1->v[1]*v2->v[1] + v1->v[2]*v2->v[2];
}

/** Oς߂
 */
void v3GetVP(VECTOR3*restrict ret, const VECTOR3*restrict v1, const VECTOR3*restrict v2)
{
	v3Set(ret,
		v1->v[1]*v2->v[2] - v1->v[2]*v2->v[1],
		v1->v[2]*v2->v[0] - v1->v[0]*v2->v[2],
		v1->v[0]*v2->v[1] - v1->v[1]*v2->v[0]);
}

/** xNg̒߂
 */
v3unit_t v3GetLength(const VECTOR3 *v)
{
	return sqrt(
		v->v[0]*v->v[0]+
		v->v[1]*v->v[1]+
		v->v[2]*v->v[2]);
}

/** 2_Ԃ̋߂
 */

v3unit_t v3GetDist(const VECTOR3*restrict to, const VECTOR3*restrict from)
{
	VECTOR3 v={
		to->v[0]-from->v[0],
		to->v[1]-from->v[1],
		to->v[2]-from->v[2]};
	return sqrt(
		v.v[0]*v.v[0]+
		v.v[1]*v.v[1]+
		v.v[2]*v.v[2]);
}

/** 2_Ԃ̍߂
 */
void v3GetVDist(VECTOR3*ret, const VECTOR3*restrict to, const VECTOR3*restrict from)
{
	v3Set(ret,
		to->v[0]-from->v[0],
		to->v[1]-from->v[1],
		to->v[2]-from->v[2]);
}


void v3Plus(VECTOR3*restrict ret, const VECTOR3*restrict to, const VECTOR3*restrict src)
{
	ret->v[0]=to->v[0]+src->v[0];
	ret->v[1]=to->v[1]+src->v[1];
	ret->v[2]=to->v[2]+src->v[2];
}

void v3Minus(VECTOR3*restrict ret, const VECTOR3* restrict to, const VECTOR3*restrict src)
{
	ret->v[0]=to->v[0]-src->v[0];
	ret->v[1]=to->v[1]-src->v[1];
	ret->v[2]=to->v[2]-src->v[2];
}

/** tosrc𑫂
 */
void v3PlusEq(VECTOR3*restrict to, const VECTOR3*restrict src)
{
	to->v[0]+=src->v[0];
	to->v[1]+=src->v[1];
	to->v[2]+=src->v[2];
}


/** tosrc
 */
void v3MinusEq(VECTOR3*restrict to, const VECTOR3* restrict src)
{
	to->v[0]-=src->v[0];
	to->v[1]-=src->v[1];
	to->v[2]-=src->v[2];
}

void v3Mult(VECTOR3*restrict to, VECTOR3*restrict src, v3unit_t d)
{
	to->v[0]=src->v[0]*d;
	to->v[1]=src->v[1]*d;
	to->v[2]=src->v[2]*d;
}

void v3MultEq(VECTOR3* to, v3unit_t d)
{
	to->v[0]*=d;
	to->v[1]*=d;
	to->v[2]*=d;
}

void v3Div(VECTOR3*restrict to, VECTOR3*restrict src, v3unit_t d)
{
	to->v[0]=src->v[0]/d;
	to->v[1]=src->v[1]/d;
	to->v[2]=src->v[2]/d;
}

void v3DivEq(VECTOR3* to, v3unit_t d)
{
	to->v[0]/=d;
	to->v[1]/=d;
	to->v[2]/=d;
}
