#include<malloc.h>

#include "debug.h"
#include "wind.h"

VECTOR3 WindForce={{0.005f, 0.0f, 0.0001f}};

void WindForceToSurface(SURFACE*pSurface)
{
	VECTOR3 Force;
	v3unit_t IP=v3GetIP(&pSurface->NormalVector, &WindForce);
	v3Mult(&Force, &pSurface->NormalVector, IP);
	SurfaceMove(pSurface, &Force);
}

void WindDoNext(void*pData)
{
	WIND *w=(WIND*)pData;
	int i;
	for(i=0; i<w->SurfaceCnt; i++)
		WindForceToSurface(w->apSurface[i]);
}

void*NewWindData(int Cnt, SURFACE**apSurface)
{
	WIND*pNew=(WIND*)malloc(sizeof(WIND));
	pNew->apSurface=apSurface;
	pNew->SurfaceCnt=Cnt;
	return (void*)pNew;
}
